#! /usr/bin/env python
# This is responsible script for running emr
import config
EMRPath=config.emrcli
import subprocess,sys,os,simplejson,time
import hadoop
sys.path.append(os.path.join(config.emrscripts,"Client"))
import CommandClient as Client
def submitNewEMRJob(domain,id,CommandLine,inputs,outputFiles,outputDir,reducer="NONE",PackFiles=None,Archives=None,Files=None,jobConf=None):
	
	
	map=hadoop.createMapperScript(CommandLine,inputs,outputFiles)
	mapFile="/home/hadoop/scripts/" + str(id)  +".py"
	#mapFile="hdfs:///home/hadoop/scripts/" + str(id)  +".py"

	f=open(mapFile,'w')
	f.write(map)
	f.close()
	#return mapFile
	cmd=hadoop.createCommand(inputs,"hdfs:///home/hadoop/outputs/" + str(id) ,mapFile,reducer,filesPack=PackFiles,cacheArchives=Archives,jobconf=jobConf,cacheFiles=Files)
	print cmd
	#return ""
	inputs.append(mapFile)
	Client.sendNewJob(domain,str(id),"hadoop",cmd,inputs,[outputDir])
	
def run(excuter,Wait=True):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	
	if Wait:
		p.wait()
		st=p.stderr.read()
		if len(st)>0:
			f = open("/tmp/ToolServiceEMR.err",'w')
			f.write(st)
			f.flush()
			f.close()
			return "Childerr:" + st
		
		else:
			return str(p.stdout.read()).strip()
	else:
		return p
if __name__=="__main__":
	mode=sys.argv[1]
	if EMRPath[-1]!="/": EMRPath+='/'
	params 	=""
	accessKey=""
	privateKey=""
	if mode=="--create":
		count=1
		insType="m1.small"
		args=sys.argv[1:]
		for arg in args:
			if "--num-instances" in arg or "-n" in arg:
				count =arg.split("=")[1]
			elif "--instance-type" in arg or "-t" in arg:
				insType=arg.split("=")[1] 
			elif "-i" in arg or "--install" in arg:
				lst=arg.split("=")[1].split(",")
				for file in lst:
						params+= "--bootstrap-action " + file +" " 
			elif "-a" in arg or "--acessKey" in arg:
				accessKey=arg.split("=")[1]
				params+="-a " + arg.split("=")[1]+" "
			elif "-p" in arg or "--privateKey" in arg:
				privateKey=arg.split("=")[1]
				params+="-p " + arg.split("=")[1]+" "
			elif "-kp" in arg or "--key-pair" in arg:
				params+="--key-pair " + arg.split("=")[1]+" "
			elif "-r" in arg or "--region" in arg:
				params+="--region " + arg.split("=")[1] +" "
			elif "-kf" in arg or "--key-pair-file" in arg:
				params+="--key-pair-file " + arg.split("=")[1] +" "
			

		cmd=EMRPath+'elastic-mapreduce --create --ami-version 2.0 --alive --num-instances %s --instance-type %s --bootstrap-action s3://eg.nubios.us/emrBoot.sh %s'%(count,insType,params)
			#cmd=EMRPath+'elastic-mapreduce --create --ami-version 2.0 --alive --num-instances %s --instance-type %s --bootstrap-action s3://eg.nubios.us/crossbow.sh'%(count,insType)
		print cmd
		#exit(0)
#		raise Exception("stopped by developer")
		res = run (cmd)
		print res
		id='j-'+res.split('j-')[1]
		
		#id='j-8HH0FOKNT62X'
		print "Started New Jobflow with id: " + id
		print "Waiting for cluster to start"
		while 1:
			r=run("ruby " + EMRPath+'elastic-mapreduce -a %s -p %s --describe %s' %(accessKey,privateKey,id))
			#print r
			try:
				res= simplejson.loads (r)
			except: 
				print r
			status= res["JobFlows"][0]["ExecutionStatusDetail"]["State"]
					
			if status=="STARTING":
				print "Will try again in 15 secs"
			
			if status=="BOOTSTRAPING":
				print "Machines Started, Running BootStrapping Script"
			if status=="WAITING":
					print "MR cluster is ready"
					domain=res["JobFlows"][0]["Instances"]["MasterPublicDnsName"]
					print "domain: " +domain
					break
			time.sleep(15)
	if mode=="--terminate":
		print run (EMRPath+'elastic-mapreduce --terminate '+sys.argv[2])
		
	if mode=="--run":
		domain=""
		jtype=""
		src=""
		ds=""
		id=""
		for arg in sys.argv[1:]:
			if "--domain" in arg or "-d=" in arg:
				domain=arg.split("=")[1]
			elif "--jobType" in arg or "-jt" in arg:
				jtype=arg.split("=")[1]
			elif "-src" in arg:
				src=arg.split("=")[1]
			elif "-dst" in arg:
				ds=arg.split("=")[1]
			elif '--id' in arg:
				id=arg.split("=")[1]
			
		if jtype=="distcp":
				cmd=hadoop.distCp(src,ds)
				#c="./CommandClient.py --run '%s' '%s' '%s' '%s' %s %s" %(domain,1,"hadoop",cmd,"[]", "[]")
				Client.sendNewJob(domain,id,"hadoop",cmd,inputs=None,outputs=None)
#				print c
				#run (c)
		
		
		
