import copy

#returns a 0-depth list containing all the elements in the input list
def GetElements(input,elements):
	for i in range(0,len(input)):
		if isinstance(input[i],list):
			GetElements(input[i],elements)
		else:
			elements.append(input[i])
	return elements

#utilized by the Cross Product function to generate the lists
def ReplaceElement(input,element,combinations="",filters="",offset=0):
	for i in range(0,len(input)):
		if isinstance(input[i],list):
			
			offset = ReplaceElement(input[i],element,combinations,filters,offset=offset)[1]
		else:
			offset+=1
			if ((offset-1)%2) == 0:
				if combinations == "_i":
					continue
			else:
				if combinations == "_2i":
					continue
			if isinstance(element,tuple):
				input[i] = element + (input[i],)
			else:
				input[i] = (element,input[i])
	RemoveNonTuples(input)
	RemoveEmptyLists(input)
	return input,offset
	
#gets the number of elements  in the list
def GetListLength(input,length=0):
	for i in range(0,len(input)):
		if isinstance(input[i],list):
			length = GetListLength(input[i],length)
		else:
			length += 1
	return length

#returns the index of the list in the given list of lists with
#the fewer number of elements
def GetShortestListIndex(inputs):
	shortest = 0
	shortestLength = GetListLength(inputs[0])
	for i in range(1,len(inputs)):
		length = GetListLength(inputs[i])
		if length < shortestLength:
			shortestLength = length
			shortest = i
	return shortest,shortestLength
	
#generates cross product of two lists
def CrossProduct(ip1,ip2,i2,combinations="_a",filters="",first=False):
	_combinations = "_a"
	if isinstance(ip1,list):
		for i in range(0,len(ip1)):
			if combinations == "_i" or  combinations == "_i2i":
				if combinations == "_i":
					_combinations = "_i"
				else:
					_combinations = "_2i"
				if (i%2) == 0 and first:
					continue
			if combinations == "_2i" or combinations == "_2ii":
				if combinations == "_2i":
					_combinations = "_2i"
				else:
					_combinations = "_i"
				if (i%2) == 1 and first:
					continue
			if isinstance(ip1[i],list):
				CrossProduct(ip1[i],ip2,i2,combinations,filters)
			else:
				ip2 = copy.deepcopy(i2)
				ip1[i] = ReplaceElement(ip2,ip1[i],_combinations,filters)[0]
		RemoveNonTuples(ip1)
		RemoveEmptyLists(ip1)

		return ip1

#gets an items at a specific position in the input list
def GetItem(input, index, currIndex=0, item = -1):
	for i in range(0,len(input)):
		if isinstance(input[i],list):
			currIndex,item = GetItem(input[i],index,currIndex,item)
		else:
			if index == currIndex:
				item =  input[i]
			currIndex += 1
	return currIndex,item

#checks if the list is composed of any empty lists
def IsEmpty(input,empty=0):
	if len(input) == 0:
		return 1
	for item in input:
		if isinstance(item,list):
			if len(item) != 0:
				empty = IsEmpty(item,empty)
			else:
				empty = 1
		else:
			empty = 0
	return empty

#removes wrong enteries from lists generated by iteration algorithms
def Correction(input,length):
	itemsToRemove = []
	for item in input:
		if isinstance(item,list):
			if IsEmpty(item):
				itemsToRemove.append(item)
			else:
				item = Correction(item,length)
				if IsEmpty(item):
					itemsToRemove.append(item)
		elif isinstance(item,tuple):
			if len(item) != length:
				itemsToRemove.append(item)
		else:
			itemsToRemove.append(item)
	for item in itemsToRemove:
		input.remove(item)
	return input
#prints the list in a human readable format
def DisplayElements(input,i=0):
	for item in input:
		if isinstance(item,tuple):
			tabs = (i-1)* "\t"
			print tabs + str(item)
		else:
			print "-----------------"
			i += 1
			DisplayElements(item,i)
			i -= 1
			print "-----------------"	
	
#sets an item at a specific position in the input list
def SetItem(input, index, item, currIndex=0, order=0):
	for i in range(0,len(input)):
		if isinstance(input[i],list):
			currIndex = SetItem(input[i],index,item,currIndex,order)
		else:
			if index == currIndex:
				if order == 1:				
					if isinstance(item,tuple):
						if isinstance(input[i],tuple):
							input[i] = item + input[i]
						else:
							input[i] = item + (input[i],)
					else:
						if isinstance(input[i],tuple):
							input[i] = (item,) + input[i]
						else:
							input[i] = (item ,)+ (input[i],)
				elif order == 2:
					input[i] = item
				else:
					if isinstance(item,tuple):
						if isinstance(input[i],tuple):
							input[i] = input[i] + item
						else:
							input[i] = (input[i],) + item
					else:
						if isinstance(input[i],tuple):
							input[i] = input[i] + (item,)
						else:
							input[i] = (input[i],item)
			currIndex += 1
	return currIndex
	

"""
def GetListDepth(input,depth=0):
	for i in range(0,len(input)):
		if isinstance(input[i],list):
			depth += 1
			depth = GetListLength(input[i],depth)
	return depth
"""


#generates dot product of two lists
def DotProduct(input1,input2,combinations="_a",first=False):
	inputs = [input1,input2]
	index,length = GetShortestListIndex(inputs)
	input1Depth = GetListDepth(input1)
	input2Depth = GetListDepth(input2)
	if input1Depth < input2Depth:
		for i in range(0,length):
			if combinations == "_i":
				if (i%2) == 0 and first:
					continue
			if combinations == "_2i":
				if (i%2) != 0 and first:
					continue
			SetItem(input2,i,GetItem(input1,i)[1],0,1)
		return input2
	else:
		for i in range(0,length):
			print i
			if combinations == "_i":
				if (i%2) == 0 and first:
					continue
			if combinations == "_2i":
				if (i%2) != 0 and first:
					continue
		
		SetItem(input1,i,GetItem(input2,i)[1])
		return input1
	
def RemoveNonTuples(input):
	for item in input:
		if isinstance(item,list):
			RemoveNonTuples(item)
		elif not isinstance(item,tuple):
			input.remove(item)

def RemoveEmptyLists(input,parent=""):
	if isinstance(input,list):
		if len(input):
			for item in input:
				if isinstance(item,list):
					RemoveEmptyLists(item,input)
		else:
			parent.remove(input)
			

#generates input with required structure
def Iteration(inputs,strategy):
	input = inputs[0]
	if strategy.startswith("dot"):
		if "_a" in strategy:
			for i in range(1,len(inputs)):
				i2 = copy.deepcopy(inputs[i])			
				input = DotProduct(input,inputs[i])
			Correction(input,len(inputs))
		if "_i" in strategy:
			for i in range(1,len(inputs)):
				if i == 1:
					first=True
				else:
					first=False
				i2 = copy.deepcopy(inputs[i])			
				input = DotProduct(input,inputs[i],"_i",first=first)
			Correction(input,len(inputs))
		if "_2i" in strategy:
			for i in range(1,len(inputs)):
				if i == 1:
					first=True
				else:
					first=False
				i2 = copy.deepcopy(inputs[i])			
				input = DotProduct(input,inputs[i],"_2i",first=first)
			Correction(input,len(inputs))
	elif strategy.startswith("cross"):
		if "_a" in strategy:
			for i in range(1,len(inputs)):
				i2 = copy.deepcopy(inputs[i])
				input = CrossProduct(input,inputs[i],i2)
		elif "_i2i" in strategy:
			for i in range(1,len(inputs)):
				if i == 1:
					first=True
				else:
					first=False
				i2 = copy.deepcopy(inputs[i])
				input = CrossProduct(input,inputs[i],i2,"_i2i",first=first)
		elif "_i" in strategy:
			for i in range(1,len(inputs)):
				if i == 1:
					first=True
				else:
					first=False
				i2 = copy.deepcopy(inputs[i])
				input = CrossProduct(input,inputs[i],i2,"_i",first=first)
		elif "_2ii" in strategy:
			for i in range(1,len(inputs)):
				if i == 1:
					first=True
				else:
					first=False
				i2 = copy.deepcopy(inputs[i])
				input = CrossProduct(input,inputs[i],i2,"_2ii",first=first)
		elif "_2i" in strategy:
			for i in range(1,len(inputs)):
				if i == 1:
					first=True
				else:
					first=False
				i2 = copy.deepcopy(inputs[i])
				input = CrossProduct(input,inputs[i],i2,"_2i",first=first)
	templateOutput = copy.deepcopy(input)
	templateOutput = EmptyList(templateOutput)
	return input,templateOutput
	
#creates an empty (-1 elements) instance of any list
def EmptyList(input):
	for i in range(0,len(input)):
		if isinstance(input[i],tuple):
			input[i] = -1
		else:
			EmptyList(input[i])
	return input


#finds the depth of the given list
def GetListDepth(input,depth=0):
	listItems = []
	for item in input:
		if isinstance(item,list):
			for i in range(0,len(item)):
				listItems.append(item[i])
	if len(listItems) > 0:
		depth += 1
		depth = GetListDepth(listItems,depth)
	return depth
	
#prepare list in case of single input
def IterateSingleInput(inputs):
	input=[]
	for i in range(0,len(inputs)):
		if isinstance(inputs[i],list):
			input.append(IterateSingleInput(inputs[i]))
		else:
			input.append((inputs[i],))
	return input
