import os
import sys
import ConfigParser
#import config
import simplejson
import xml.dom.minidom
import random
import listIteration
import copy
import thread
#sys.path.append(config.scriptsPath)
#sys.path.append(config.cloudRunner)
#import CommandClient
import utils
import HPCLoudEMR
#import metadata
import time
import tempfile
from Cheetah.Template import Template
from threading import Thread,Lock
from subprocess import Popen
#from PBS import runAsPBSJob,checkPBSstatus, getStdoutStderr,getNumberOfCores

def TerminateCluster():
	CommandClient.terminateOnFinsih(domain)

def RemoveFiles():
	return 0
	global filesToRemove
	filesToRemove = " ".join(filesToRemove)
	command = "python " + os.path.join(config.toolsDirect,"filesAvailability.py") + " remove " + filesToRemove
	#os.system(command)  
	
def SendFiles():
	return 0 
	global filesToSend
	filesToSend = " ".join(filesToSend)
	command = "python " + os.path.join(config.toolsDirect,"filesAvailability.py") + " post " + filesToSend
	#os.system(command)  

def GetFile(filePath):
	return 0 
	command = "python " + os.path.join(config.toolsDirect,"filesAvailability.py") + " pre " + filePath
	#os.system(command)  

def GetListOfInputsOutputs(params,listOfInputsOutputs=[]):
	for param, paramValues in params.items():
		if not "dir" in paramValues:
			GetListOfInputsOutputs(paramValues,listOfInputsOutputs)
		else:
			if "database" in paramValues:
				if not paramValues["database"]:
					listOfInputsOutputs.append((paramValues["dir"],paramValues["value"]))
			else:
				listOfInputsOutputs.append((paramValues["dir"],paramValues["value"]))

def AdjustDatabases(params,cacheArchives,config):
	for paramName, param in params.items():
		if isinstance(param,dict):
			for itemName,item in param.items():				
				if isinstance(item,dict):
					AdjustDatabases(item,cacheArchives,config)
			if "database" in param:
				if param["database"] == True:
					cacheArchives.append(config.get("Databases",param["value"]))
		
		if paramName == "database":
			cacheArchives.append(config.get("Databases",params["value"]))

def ExecuteCommand(cmd,params={},single=True):
	if infrastructure == "local":
		if config.cluster == "off" or single:
			if config.cluster == "on":
				id = utils.GetRandomString()
				pbsID = runAsPBSJob("Tavaxy",id,cmd)
				
				status = checkPBSstatus(pbsID)
				while status != "C" and status != "E":
					status = checkPBSstatus(pbsID)
					time.sleep(1)
					
				getStdoutStderr(pbsID)
			else:
				os.system(cmd)
		else:
			pre_cmd = "python " + os.path.join(config.toolsDirect,"filesAvailability.py") + " pre "
			post_cmd = "python " + os.path.join(config.toolsDirect,"filesAvailability.py") + " post "
			listOfInputsOutputs = []
			GetListOfInputsOutputs(params,listOfInputsOutputs)
			for item in listOfInputsOutputs:
				if item[0] == "input":
					pre_cmd += item[1] + " "
				elif item[0] == "output":
					post_cmd += item[1] + " "

			pre_cmd += ";"
			post_cmd += ";"
			
			id = utils.GetRandomString()
			cmd = pre_cmd + cmd + ";" + post_cmd
			pbsID = runAsPBSJob("Tavaxy",id,cmd)
			
			status = checkPBSstatus(pbsID)
			while status != "C" and status != "E":
				status = checkPBSstatus(pbsID)
				time.sleep(5)
			getStdoutStderr(pbsID)
	elif infrastructure == "cloud":
		tof,domain = sys.argv[5].split("__sep__")
		tof = int(tof)
		id = utils.GetRandomString()
		inputs = [] 
		outputs = []
		
		pre_cmd = "python " + os.path.join(config.toolsDirect,"filesAvailability.py") + " pre "
		post_cmd = "python " + os.path.join(config.toolsDirect,"filesAvailability.py") + " post "


		listOfInputsOutputs = []
		GetListOfInputsOutputs(params,listOfInputsOutputs)
		for item in listOfInputsOutputs:
			if item[0] == "input":
				inputs.append(item[1])
				try:
					value = simplejson.loads(open(item[1]).read().strip())
					value = utils.GetProperList(value)
				
					if isinstance(value,list):
						files = []
						listIteration.GetElements(value,files)
						for file in files:
							inputs.append(file)
					else:
						inputs.append(value)
				
				except:
					pass
				pre_cmd += item[1] + " "
			elif item[0] == "output":
				outputs.append(item[1])
				post_cmd += item[1] + " "

		pre_cmd += ";"
		post_cmd += ";"

		cmdArgs = cmd.split(" ")
		for arg in cmdArgs:
			if os.path.isfile(arg):
				if arg not in inputs and arg not in outputs:
					inputs.append(arg)
			
		cmd = pre_cmd + cmd + ";" + post_cmd
			
		CommandClient.sendNewJob(domain,id,"Tavaxy",cmd,inputs,outputs)
		
		#Get output files that are referenced
		for output in outputs:
			try:
				value = simplejson.loads(open(output).read().strip())
				value = utils.GetProperList(value)

				if isinstance(value,list):
					files = []
					listIteration.GetElements(value,files)
					CommandClient.fetchFile(id,"Tavaxy",domain,files)
				else:
					CommandClient.fetchFile(id,"Tavaxy",domain,[value])
			
			except:
				pass
	elif infrastructure == "emr":
		cacheFiles = []
		cacheArchives = []
		executableElement = doc.getElementsByTagName("executable")[0]
		executable = executableElement.firstChild.nodeValue
		configFile = "emr.conf"
		config = ConfigParser.RawConfigParser()
		config.read(configFile)
		executable = config.get("Executables",executable)
		cacheFiles.append(executable)
		AdjustDatabases(params,cacheArchives,config)
		
		
		tof,domain = sys.argv[5].split("__sep__")
		tof = int(tof)
		id = utils.GetRandomString()
		inputs = [] 
		outputs = []
		
		#pre_cmd = "python " + os.path.join(config.toolsDirect,"filesAvailability.py") + " pre "
		#post_cmd = "python " + os.path.join(config.toolsDirect,"filesAvailability.py") + " post "

		listOfInputsOutputs = []
		GetListOfInputsOutputs(params,listOfInputsOutputs)

		for item in listOfInputsOutputs:
			if item[0] == "input":
				inputs.append(item[1])
				#pre_cmd += item[1] + " "
			elif item[0] == "output":
				outputs.append(item[1])
		#		post_cmd += item[1] + " "
		#pre_cmd += ";"
		#post_cmd += ";"

		cmdArgs = cmd.split(" ")
		for arg in cmdArgs:
			if os.path.isfile(arg):
				if arg not in inputs and arg not in outputs:
					inputs.append(arg)
			
		#cmd = pre_cmd + cmd + ";" + post_cmd
			
		#CommandClient.sendNewJob(domain,id,"Tavaxy",cmd,inputs,outputs)
		
		#Get output files that are referenced
		#for output in outputs:
		#	try:
		#		value = simplejson.loads(open(output).read().strip())
		#		value = utils.GetProperList(value)
		#
		#		if isinstance(value,list):
		#			files = []
		#			listIteration.GetElements(value,files)
		#			CommandClient.fetchFile(id,"Tavaxy",domain,files)
		#		else:
		#			CommandClient.fetchFile(id,"Tavaxy",domain,[value])
			
		#	except:
		#		pass

		

		reduce="NONE"
		
		conf=["mapred.reduce.tasks=1","mapred.map.tasks=2"]
		
		outputDir = "/home/hadoop/" + utils.GetRandomString()
		os.mkdir(outputDir)
		print domain
		print id
		print cmd
		print inputs
		print outputDir
		print outputs
		print reduce
		print cacheArchives
		print cacheFiles
		print conf
		print
		print "executing"
		print cmd
		HPCLoudEMR.submitNewEMRJob(domain,id,cmd,inputs,outputs,outputDir,reducer=reduce,Archives=cacheArchives ,Files=cacheFiles,jobConf=conf)
		exit()
class CommandExecutionThread(Thread):

    def __init__(self,cmd,index,params):

        Thread.__init__(self)
        self.cmd=cmd
        self.index=index
        self.params=params
    
    def run(self):
		try:
			ExecuteCommand(self.cmd,self.params,single=False)
		finally:
			threads.remove(self)
		

def PrepareCommand(command,params):
	command = command.split(" ")
	executableName = command[0]
	interpreter = command[1]
	if infrastructure == "emr":
		command = " ".join(command[2:])
		command = command.replace("-cp","-cp " + toolPath + " ")
		command = command.replace(executableName,"./"+executableName,1)
	else:
		if interpreter != "none":
			command = " ".join(command[1:])
			command = command.replace("-cp","-cp " + toolPath + " ")
			command = command.replace(executableName,os.path.join(toolPath,executableName) + " ")
		else:
			command = " ".join(command[2:])
	command = str( Template( source=command, searchList=[params] ) )
	command = command.replace("  "," ").replace("__gt__",">").replace("__and__","&")
	#command += " 2>&1"
	return command


def TraverseInputList(input,index=0):
	for item in input:
		if isinstance(item,tuple):
			commandInstance = toolCommand
			params = {}
			
			for j in range(0,len(item)):
				inputPort = {}
				inputPort["format"] = inputPorts[j]["format"]
				inputPort["name"] = inputPorts[j]["name"]
				inputPort["value"] = item[j]
				inputPort["extension"] = item[j].split(".")[-1]
				inputPort["database"] = inputPorts[j]["database"]
				inputPort["query"] = inputPorts[j]["query"]
				PrepareParam(inputPort,params)
			
			for outputPort in outputPorts:
				path = outputPort["path"]
				params[outputPort["name"]] = {}
				params[outputPort["name"]]["value"] = path + "_" + str(index)
				#add path + "_" + str(index) to the list of files to send
				params[outputPort["name"]]["dir"] = "output"
				f = open(path + "_" + str(index),"w")
				f.write("")
				f.close()			
				listIteration.SetItem(outputPort["value"],index,path + "_" + str(index),0,2)

			
			commandInstance = PrepareCommand(commandInstance,params)
			
			
			thread = CommandExecutionThread(commandInstance,index,params)

			l.acquire()
			
			
			#while len(threads) >= parallelJobs:
			#	time.sleep(5)

			threads.append(thread)
			thread.start()
			#if infrastructure == "emr":
			#	thread.join()
			
			index += 1
			
			l.release()
		else:
			index = TraverseInputList(item,index)
	return index

def GetFilePath(argName,direction):
	try:
		global toolCommand
		filePath = toolCommand.split("p|"+argName+" ")[1].split(" ")[0]
		toolCommand = toolCommand.replace("p|"+argName + " " + filePath,"$"+argName+".value")
		filePath = filePath.replace("'","").replace('"',"")
		return filePath
	except:
		return -1

def GetParamName(element,suffix=""):
	name = element.getAttribute("name")
	if element.parentNode.nodeName == "inputs":
		if suffix == "":
			return name
		else:
			return name + "." + suffix
	elif element.parentNode.nodeName == "when":
		if suffix != "":
			name = name + "." + suffix
		return GetParamName(element.parentNode.parentNode,name)
	elif element.parentNode.nodeName == "conditional":
		if suffix != "":
			name = name + "." + suffix
		return GetParamName(element.parentNode,name)

def PrepareParam(inputPort,params):
	name = inputPort["name"]
	element = params
	while "." in name:
		parentName = name.split(".")[0]
		name = name.split(".")[1]
		if parentName not in element:
			element[parentName] = {}
		element = element[parentName]
	element[name] = {}
	element[name]["database"] = inputPort["database"]
	element[name]["query"] = inputPort["query"]
	element[name]["value"] = inputPort["value"]
	element[name]["extension"] = inputPort["extension"]
	element[name]["format"] = inputPort["format"]
	#element[name]["metadata"] = metadata.GenerateMetadata(inputPort["value"],inputPort["format"])
	element[name]["dir"] = "input"

def SetOptionValue(optionName):
	try:
		global toolCommand
		originalValue = toolCommand.split("o|"+optionName+" ")[1].split(" ")[0]
		optionValue = None
		if paramFile is not None:
			try:
				optionValue = paramFile.get('params',optionName)
			except:
				optionValue = None
		if optionValue is None:
			toolCommand = toolCommand.replace("o|"+optionName + " " + originalValue,originalValue)
		else:
			toolCommand = toolCommand.replace("o|"+optionName + " " + originalValue,optionValue)
	except:
		return -1
	
filesToSend = []
filesToRemove = []
l = Lock()
threads = []	

#parallelJobs = int(config.parallelJobs)
#if parallelJobs == 0:
#	if config.cluster == "on":
#		parallelJobs = getNumberOfCores()
#	else:
#		import multiprocessing
#		parallelJobs = multiprocessing.cpu_count()
	
dummyFile = sys.argv[3]
execute = 1
listEnabled = False
hasDependency,toolID = sys.argv[1].replace("__ss__"," ").split("__sep__")
hasDependency = int(hasDependency)
dependency = 1
if (not os.path.isfile(dummyFile)) and hasDependency:
	dependency = 0
command = " ".join(sys.argv)
toolCommand = command.split("__command__")[1].strip()	
toolCommand = toolCommand.replace("__sep__","|").replace("__dq__",'"').replace("__sq__","'").replace("__ds__","$").replace("__ss__"," ").replace("__obcs__","(").replace("__cbcs__",")").replace("__oc__","{").replace("__cc__","}").replace("__ob__","[").replace("__cb__","]").replace("__at__","@")

infrastructure = sys.argv[4]
tof = False

#toolPath = os.path.join(config.toolsDirect, utils.GetToolPath(toolID))
toolPath = "/home/shady/MyWork2/emr/MyScripts/ncbi_blastn_wrapper.xml"

doc = xml.dom.minidom.parse(toolPath)


#toolPath = toolPath.split("/")
#toolPath = "/".join(toolPath[0:len(toolPath)-1])

inputPorts = []
inputElements = doc.getElementsByTagName("inputs")[0].getElementsByTagName("param")
outputPorts = []
outputElements = doc.getElementsByTagName("outputs")[0].getElementsByTagName("data")


def PrepareSinglelineInput(value,format):
	elements = []
	if isinstance(value,list):
		listIteration.GetElements(value,elements)
	else:
		elements.append(value)
	if "fasta" in format:
		return value
		output = ""
		for item in elements:
			file = open(item).read().strip()
			#output+=file
			#continue
			seqs = file.split(">")
			for seq in seqs:
				if seq != "":
					seq = seq.split("\n")
					header = seq[0]
					seq = "".join(seq[1:])
					output += header+"||"+seq+"\n"
		file = tempfile.NamedTemporaryFile()
		fileName = "/home/hadoop/"+utils.GetRandomString()
		print fileName
		file = open(fileName,"w")
		file.write(output.strip())
		file.flush()
		file.close()
		return [fileName]
	elif "fastq" in format:
		pass
	else:
		return value

try:
	GetFile(sys.argv[7])
	paramFile = ConfigParser.RawConfigParser()
	paramFile.read(simplejson.loads(open(sys.argv[7]).read()))
except:
	paramFile = None

for inputElement in inputElements:
	type = inputElement.getAttribute("type")
	format = inputElement.getAttribute("format")
	name = GetParamName(inputElement)
	if not inputElement.getAttribute("hidden") and type == "data" and not inputElement.getAttribute("dummy"):
		
		filePath = GetFilePath(name,"i")
		
		if filePath == -1:
			continue
		else:
			GetFile(filePath)
		if os.path.isfile(filePath):
			value = simplejson.loads(open(filePath).read().strip())
			value = utils.GetProperList(value)
			
			query = False
			database = False
			
			if infrastructure == "emr":
				if inputElement.getAttribute("query"):
					query = True
					value = PrepareSinglelineInput(value,format)
				if inputElement.getAttribute("database"):
					database = True
			
			if not isinstance(value,list):
				value = [value]

			inputDepth = listIteration.GetListDepth(value)
			portDepth = inputElement.getAttribute("depth")
			if portDepth != "inf":
				portDepth = int(portDepth)
				if portDepth < inputDepth or (inputDepth == 0 and portDepth == 0 and len(value) > 1) :
					listEnabled = True
			input = {"name":name,"type":type,"value":value,"depth":portDepth,"path":filePath,"format":format,"query":query,"database":database}
			inputPorts.append(input)
		else:
			execute = 0
			break
	else:
		SetOptionValue(name)
	
for outputElement in outputElements:
	name = outputElement.getAttribute("name")
	filePath = GetFilePath(name,"o")
	filesToSend.append(filePath)
	outputPorts.append({"name":name,"value":"","path":filePath})

if execute and dependency:
	if listEnabled:
		inputs = []
		for inputPort in inputPorts:
			inputs.append(inputPort["value"])


		print inputs
		strategy = sys.argv[2]
		if len(inputs) == 1:
			input = listIteration.IterateSingleInput(inputs[0])
			templateOutput = copy.deepcopy(input)
			templateOutput = listIteration.EmptyList(templateOutput)
		else:
			input,templateOutput = listIteration.Iteration(inputs,strategy)
		
	
		for outputPort in outputPorts:
			outputPort["value"] = copy.deepcopy(templateOutput)

		rands =[]
		#traverse the input list, for each entry run the tool
		TraverseInputList(input)
		for thread in threads:
			thread.join()

	
		for outputPort in outputPorts:
			value = utils.CollectUnreferencedFiles(outputPort["value"])
			open(outputPort["path"],'w').write(simplejson.dumps(value))
		
		for k in range(0,len(rands)):
			os.remove(rands[k])
		
		SendFiles()
		
	else:
		params = {}
		for inputPort in inputPorts:
			if inputPort["depth"] == 0:
				inputPort["value"] = inputPort["value"][0]
				inputPort["extension"] = inputPort["value"].split(".")[-1]	
			else:
				inputPort["extension"] = ""
				inputPort["value"] = inputPort["path"]
			PrepareParam(inputPort,params)
	
		for outputPort in outputPorts:
			path = outputPort["path"]
			params[outputPort["name"]] = {}
			params[outputPort["name"]]["value"] = path + "_0"
			params[outputPort["name"]]["dir"] = "output"
			f = open(path + "_0","w")
			f.write("")
			f.close()

		toolCommand = PrepareCommand(toolCommand,params)
	
		ExecuteCommand(toolCommand,params)
		
		for outputPort in outputPorts:
			value = utils.CollectUnreferencedFiles([outputPort["path"] + "_0"])
			open(outputPort["path"],'w').write(simplejson.dumps(value))

		SendFiles()
else:
	#print "tool wont execute"
	for i in range(0,len(outputPorts)):
		if os.path.isfile(outputPorts[i]["path"]):
			os.remove(outputPorts[i]["path"])
			filesToRemove.append(outputPorts[i]["path"])
			#add outputPorts[i]["path"] to the list of files ot remove
	RemoveFiles()

if infrastructure == "cloud" and tof:
	TerminateCluster()
	pass
