import os,subprocess,simplejson,math
mainPath=os.path.dirname(os.path.abspath( __file__ ))
region="EU1"
def getMetaInfo(info):
        return run("wget -q -O - http://169.254.169.254/latest/meta-data/%s/"%(info),True)

def sharedFS():
	FS={"NFS":None,"S3":None}
	if os.path.exists('/root/EHPC/NFSinfo'):
		file=open('/root/EHPC/NFSinfo','r')
		nfsMountPoint=file.read().strip()
		file.close()
		FS["NFS"]=nfsMountPoint
	
	if os.path.exists('/root/EHPC/S3info'):
		file=open('/root/EHPC/S3info','r')
		lst=file.read().split(',')
		file.close()
		s3Bucket=lst[0]
		s3MountPoint=lst[1]
		s3TempDir=lst[2]
		FS["S3"]={"s3Bucket":s3Bucket,"s3MountPoint":s3MountPoint,"s3TempDir":s3TempDir}
	return simplejson.dumps(FS)
def run(excuter,Wait=False):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	if (Wait):
		p.wait()
		st=p.stderr.read()
		if len(st)>0:
			f = open("/tmp/ToolService.err",'w')
			f.write(st)
			f.flush()
			f.close()
			return "Childerr:" + st
		else:
			return str(p.stdout.read()).strip()
	else:
		return p
def fetch(insId):
	global region
	if insId=='':
		return ""
	mainPath=os.path.dirname(os.path.abspath( __file__ ))
	command= mainPath+"/EC2.2 " + region + " --info " + insId
	#return command
	t = run(command,True)
	#return t
	d={}
	info=t.split()
#	return info
	d["InstanceID"] =insId
	d["AMIID"]=info[6]
 	d["InstanceType"]=info[12]
        d["Zone"]= info[14]
        d["Status"]= info[9]
        d["PublicDNS"]= info[7]
        d["InstanceType"]=info[12]
        d["PrivateIP"]= info[18] 
        d["SecurityGroup"]=info[3]
        d["KeyPair"]=info[10]
	vols = t.split("BLOCKDEVICE ")[2:]
	d["ExtraVols"]=[]	
	if len(vols)>0:
		for vol in vols:
			v={}
			vo=vol.split()
			v["id"]=vo[1]
			v["path"]=vo[0]
			d["ExtraVols"].append(v)
	else:
		d["ExtraVols"].append("N/A")	
#	k=t.split("\n")
	#return k
#	for line in k:
	#	return  line
#		s=line.strip().split(": ")
#		d[s[0]]=s[1][:-2]

	
	return simplejson.dumps(d)
def getAllNodesFast():
	
	try:
		f=open('/root/nodesList','r')
		l=f.readlines()
	except:
		d={}
		d["err"]= "Cluster is n't created yet, please <a href='/setup'>Visit Setup Page </a>"
		return simplejson.dumps(d)
	if len(l)==0:
		return "Cluster is n't created yet, please <a href='/setup'>Visit Setup Page </a>"
	l=[k.strip() for k in l]
	info=[]
	for node in l:
		n={}
		n["id"]=node
#		n["status"]=run(mainPath+"/EC2 " + region + " --status " + node,True)
		info.append(n)
	return simplejson.dumps(info)


def getAllNodes():
	global region	
	try:
		f=open('/root/nodesList','r')
		l=f.readlines()
	except:
		d={}
		d["err"]= "Cluster is n't created yet, please <a href='/setup'>Visit Setup Page </a>"
		return simplejson.dumps(d)
	if len(l)==0:
		return "Cluster is n't created yet, please <a href='/setup'>Visit Setup Page </a>"
	l=[k.strip() for k in l]
	info=[]
	ids= ' '.join(l)
	n={}
	text=run(mainPath+"/EC2.2 " + region + " --info " +  ids,True)
#	return text
	instances=text.split("INSTANCE ")[1:]
#	return simplejson.dumps(instances)
	for ins in instances:
		#print ins
		n={}
		values=ins.split()
		n["id"]=values[0]
		since=values[8].replace("+0000","Z")
		diff= getTimeDifference(since)	
		Name=ins.split ("Name ")
                #print Name
                name=Name[1].split(' ')[0]
                cell=[values[0],name,values[7],values[9],values[4],str(diff) +" hours","<u><a href='#' onclick='fetchInfo(event)' id='more-" + values[0] + "'>More...</a></u>"]

#		cell=[values[0],values[7],values[9],values[4],str(diff) +" hours","<u><a href='#' onclick='fetchInfo(event)' id='more-" + values[0] + "'>More...</a></u>"]
		n["cell"]=cell
		info.append(n)
	d={"page":"1","total":1,"records": str(len(info)),"rows":info}
	return simplejson.dumps(d)

def getAllZones():
	global region
#	return "Not Implemented yet"
#	global mainPath
	zones =run(mainPath+"/EC2.2 " + region + " --zones",True).split("\n")
	z = []
	for zone in zones:
		z.append(zone.split("\t")[1])
	return simplejson.dumps(z)

def getNodeZone(instanceID):
	id=run("wget -q -O - http://169.254.169.254/latest/meta-data/instance-id",True)
	if id==instanceID:
		return run("wget -q -O - http://169.254.169.254/latest/meta-data/placement/availability-zone",True)
	f=open('/root/stats','r')
	t=f.read()
	info=simplejson.loads(t)
	f.close()
	return info[instanceID].split()[6]

#	return  run(mainPath+"/EC2 " + region + " --zone " + instanceID,True)
def addNode(machine,count='1'):
	lst=machine.split(',')
		
	c="/root/EHPC/CommandClient.py --run 127.0.0.1 '3' 'system' '/root/EHPC/HPCcloud-createCluster --add-node -t=%s -n=%s --extraMachinesPBSCores=%s &'"%(lst[0],count,lst[1])
#	return c
	run (c)
	import time
	time.sleep(10)
	return "Machine is starting...."

def terminate(id):
	c="/root/EHPC/CommandClient.py --run 127.0.0.1 '3' 'system' '/root/EHPC/terminateNode.py " + id + " &'"
        #return c
        run (c)
	return "Machine is shutting Down...."
def terminateCluster():
	c="/root/EHPC/terminateCluster.py --sucide"
	run(c)
	return "Clustering is shutting down now...."
def avaVolumesZone(zone):
	global region
	x=run("/root/EHPC/EC2.2 " +region + " --ava-volumes-zone " + zone,True ).strip()
	x=x.replace("+0000\n","+0000\t")
	#print x
#	return x
	lines=x.split('VOLUME')
	if len(lines)==1 and lines[0]=='':
		return simplejson.dumps(["No Volumes avaliable in " +  zone])
	#print lines
#	return lines
	d=[]
	for line in lines:
        	v={}
	        l=line.split()
		if len(l)==0:
			continue
        #	print "l=" , l
	        v["id"]=l[0]
        	v["size"]=l[1]
	        if "snap-" in l:
        	        v["snapshot-id"]=l[2]
                	v["zone"]=l[3]
	                v["status"]=l[4]
        	        v["created_on"]=l[5]
	        else:
        	        v["zone"]=l[2]
                	v["status"]=l[3]
	                v["created_on"]=l[4]
        	if "Name" in l:
                	v["name"]=l[l.index("Name")+1]
	        d.append(v)

	return simplejson.dumps(d)
def attachMount(instanceID, volID, device,mountPoint,format):
	global region
	#return volID
	x=run(mainPath+"/EC2.2 " + region  + " --attach %s %s %s" %(volID,instanceID,device),True)
#	return x
	command= mainPath+"/EC2.2 " + region + " --details " + instanceID
	t = run(command,True)
        k=t.split("\n")
	domain=""
#	return k
        for line in k:
                s=line.strip().split(": ")
               	if s[0]=="PublicDNS":
			 domain=s[1][:-2]
#	return format
	
	cmd= "/root/EHPC/CommandClient.py --run " + domain + " 5 'system' 'python /root/EHPC/mount.py %s %s %s'"%(device,mountPoint,format)
	print cmd
	#return cmd
        p=run(cmd,True)
	return p

def getVolInfo(volID):
	global region
	text=run(mainPath+"/EC2.2 "+ region + " --volume " + volID,True)
	v=text.split()
#	return v
	vol={}
	vol["id"]=v[1]
	vol["size"]=v[2]
	i=2
	if "snap-" in text:
		vol["snapshot"]=v[3]
		i=3
	else:
		vol["snapshot"]="N/A"
	vol["createdOn"]=v[i+3]
	vol["device"]=v[i+7]
	vol["attachedOn"]=v[i+9]
	return simplejson.dumps(vol)
if __name__=="__main__":
	print getAllNodes()
def createVolume(size, zone):
	global region
	t=run(mainPath+"/EC2.2 " + region + " --create-volume " + size + " " + zone,True)
	return t.split()[1]

def getMachinesTypes():
	f=open("/root/stats",'r')
	d=simplejson.loads(f.read())
	res={}
	res["t1.micro"]=0
	res["m1.large"]=0
	res["m1.xlarge"]=0
	type=run("wget -q -O - http://169.254.169.254/latest/meta-data/instance-type",True)
	res[type]+=1
	for m in d.keys():
		res[d[m].split()[4]]+=1
	return str(res)[1:-1]
def getQueueState():
	run('/root/EHPC/CommandClient.py --run 127.0.0.1 1 system "qstat > /root/queue" "" "/root/queue"',True)
	f=open('/root/queue','r')
	t=f.read()
	if t=='':
		return '<span style="color:#32CD32">Empty Queue</span>'
	else:
		res={}
		res["Completed"]=len(t.split(" C "))-1
		res["Running"]=len(t.split(" R "))-1
		res["Queued"]=len(t.split(" Q "))-1
		res["Held"]=len(t.split(" H "))-1
		return str(res)[1:-1]
def attachSnapShot(snapshotID,devicePath,mountPoint):
	global region
	f=open('/root/nodesList','r')
	nodes=f.readlines()
	zone=getMetaInfo("placement/availability-zone")
	for i  in range(0,len(nodes)):
		if ",X" in nodes[i]: continue #Terminated
		insID=nodes[i].strip()
#		zone=getNodeZone(insID)
#		print "Node " + insID + " is at " + zone
		volume=run(mainPath+"/EC2.2 " + region + " --create-vol-from-snapshot " +  snapshotID + " " + zone,True).split()[1]
		print "New Vol: " + volume
		attachMount(insID,volume,devicePath,mountPoint,'N')
	return "Done"
if __name__=="__main__":
	attachSnapShot("snap-15ac447d","/dev/sdg","/testShot")
def getTimeDifference(since):
	try:
		from datetime import datetime
		date=since.split("T")[0]
		time=since.split("T")[1][:-1]
		d=date.split("-")
	except:
		print since
	y=int(d[0])
	M=int(d[1])
	dd=int(d[2])
#	return dd 
	t=time.split(":")
	h=int(t[0])
	m=int(t[1])
	s=int(t[2])

	l=datetime(year=y,month=M,day=dd,hour=h,minute=m,second=s)
#	return l
#	return date+time
	now=datetime.utcnow()
	span=now-l
	total=span.total_seconds()/3600
#	return total
	return math.ceil(total)
#	return now

"""def getSnapshotList():
	f=open('/root/snapshotlist.json','r')
	shots=simplejson.loads(f.read())
	f.close()
	info=[]
	
	for s in shots:
		n={}
		n["id"]=s["id"]
         	n["name"]=s["name"]
		n["mounted"]=s["mounted"]
                cell=[n["id"],n["name"],n["mounted"],'']
                n["cell"]=cell
                info.append(n)
        d={"page":"1","total":1,"records": str(len(info)),"rows":info}
	return simplejson.dumps(d)
"""
def getSnapshotList():
	f=open('/var/www/cluster/conf/snapshots.json','r')
	js = f.read()
	dbs=simplejson.loads(js)
	html="<ul>"
	for item in dbs.keys():
		html+="<li id='" + item.replace(" ","_")+"'><a href='#'>"+item.strip()+"</a>"
		html+="<ul>"
		for db in dbs[item].keys():
			html+="<li id='" + db.strip()+"' snapid='" + dbs[item][db]["snapshot"] +"'><a href='#'>" + db.strip()+"</a></li>"
		html+="</ul></li>"
	html+="</ul>"
	return html
	
