#! /usr/bin/python
						############################################
						## 					  					  ##
						## This is NUBIOS Tool Submission Handler ##
						## Written By Mohamed M. El-Kalioby	  	  ##
						## For: NUBIOS				  			  ##
						## In: Dec 2009				  			  ##
						## Last Update: Mar 2011	          	  ##
						##					  					  ##
						############################################
import os, MySQLdb,subprocess,random ,Utils,config
from mod_python import util,Cookie,apache
						
#Start Configuration Parameters  

BaseURL=config.WebBaseURL
BaseStorageFolder=config.WebBaseStorageFolder
ResultsBaseURL=config.WebResultsBaseURL
BaseTempPath=config.WebBaseTempPath
LocationOfUserManagementJar=config.WebLocationOfUserManagementJar
FilesURL=config.WebFilesURL

# End Configuration Parameters    

#General Variables
uid=''
path=''
toolName=''
MultipleInputsParameters={}
fileparams=[]


#This function test if the input file is a list of inputs 
def SplitMultipleInputs(inputName,lines):
	global path
	global MultipleInputsParameters
	i=1
	debugFile=open(path+'lines','w')
	debugFile.write(lines)
	if ("#$" in lines):
		
		#MultipleInputsParameters.append(inputName)
		l = lines.split("#$\r\n")
		debugFile.write("Lines:" + str(l))
		st=""
		debugFile.write("\n\n")
		#print l
		for input in l:
			debugFile.write(input)
			fname=path+inputName+str(i)
			if (input!=l[-1]):
				st += fname + ","
			else:
				st +=fname
			f=open(fname,'w')
			f.write(input)
			f.flush()
			f.close()
			i=i+1
		MultipleInputsParameters[inputName]=st
		debugFile.write(str(MultipleInputsParameters))
		debugFile.flush()
		debugFile.close()

		#return MultipleInputsParameters
	return i

#get user uid from req
def getUid(req):
	c = Cookie.get_cookies(req).get("mart.Login",None)
	global uid
	if (c):
		uid=c.value	
		
	else: #return IP
		#return req.subprocess_env
		uid=req.connection.remote_ip
	return uid

# Redirect function
def redirect(url,req):
	  util.redirect(req,  url)

# Run the prepared command
def run(excuter):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	p.wait()
	st=p.stderr.read()
	if len(st)>0:
		f = open("/tmp/ToolService.err",'w')
		f.write(st)
		f.flush()
		f.close()
		return "Childerr:", st
		
	else:
		return p.stdout.read()

# Execute an Operation using the UserManagement API
def getManagementValue(op,params):
	global LocationOfUserManagementJar,BaseStorageFolder,uid,toolName
	command="java -jar " + LocationOfUserManagementJar + " " 
	if (op=="dir"):
		command += "-dir " + toolName + " "  + uid + " " + BaseStorageFolder
	else:
		for p in params:
			command += p
			if (p!=params[-1]):
				command+=" " 
	#	return command
	PIPE=subprocess.PIPE
        p=subprocess.Popen(command,stdout=PIPE,stderr=PIPE,shell=True)
        p.wait()
	if (op=="execute"):
		s = p.stdout.read().strip()
#		return s
		return s.split("\n")[-1]
	else:	
		return p.stdout.read().strip() + "/" #+ p.stderr.read()

# returns the path of a user random directory to use.
def getRandomDir():
	global uid,BaseStorageFolder
	return getManagementValue("dir",None)

# Creates a shell file from the command
def createShellFile(executer,path):
	f = open(path +'runner.sh','w')
	f.write(executer+"\n")
	f.write("touch " + path + "Finished.txt\n")
	f.flush()
	f.close()
	return path + "runner.sh"

# Run the commad using the user management API
def runWithUserManagement(executer):
	global path,toolName, uid
	file = createShellFile(executer,path)
	params=[toolName,uid,file]
	return getManagementValue("execute",params) 	
			
# File Read
def fbuffer(f, chunk_size=10000):
   while True:
      chunk = f.read(chunk_size)
      if not chunk: break
      yield chunk

# Get the value of the parameters and if type is file upload it
def GetData(ParamName,req,path,file=False):
	
	message=""
	global fileparams
	#return "keys" + str(req.form.keys())
	
#		return 'files' + str(fileparams)
	try: # Windows needs stdio set for binary mode.
		import msvcrt
		msvcrt.setmode (0, os.O_BINARY) # stdin  = 0
		msvcrt.setmode (1, os.O_BINARY) # stdout = 1
	except ImportError:
	      pass
	if ("out_" in ParamName):
		return ""
  	fileitem = req.form[ParamName]
	
   # Test if the file was uploaded
   	if fileitem.filename:

      # strip leading path from file name to avoid directory traversal attacks
		fname = os.path.basename(fileitem.filename)
     
      # build absolute path to files directory
      		fpath=path +fname
      		#return fpath	
		f = open(fpath, 'wb', 10000)
     # Read the file in chunks
		for chunk in fbuffer(fileitem.file):
			f.write(chunk)
		f.close()
		message = fpath
	elif (req.form[ParamName].value!=""):
		if (ParamName.find("file")>-1 or ParamName.split('_')[0] in fileparams ):
		#	return  " File: "  + ParamName
			
			st =str(req.form[ParamName].value)
			
			if (not "#$" in st):   #Single Input Mode
				fpath = path + ParamName.split('_')[0]
				#	return fpath
				f = open(fpath,'w')
				f.write(st)
				#return req.form[ParamName].value
				f.flush()
				#os.fsync(f)
				f.close()
				message=fpath 
			else:
				SplitMultipleInputs(ParamName.split('_')[0],st)
				message="$" + ParamName.split('_')[0]
			#return ParamName
		else:
			message = req.form[ParamName].value
	else:
		message=""
	return message

			#####################################
			##								   ##
			##	      Main Handler  		   ##
			##				   				   ##
			#####################################               

def process(req):
	#st=''
	#for key in req.form.keys():
	#	st+= key +': '+ req.form[key].value+','
	#return st
   	message=""
	parameters={}
   	l= req.form.list
   	intOrderID=-1
   	global path,fileparams
	outfile=''
	AddOutPutRedirection=True
	getUid(req)
	global toolName
   	toolName = req.form['toolName'].value
   	if ('dataFields' in req.form.keys()):
		fileparams=req.form['dataFields'].split(",")
		
   	if ( " -" in toolName ):
		toolName=toolName.split(" -")[1]
	#if (intOrderID<0):
		#path=getRandomDir()
	#	intOrderID=path.split("/")[-2]
		
	if ("jobName" in req.form.keys()):
		path=BaseStorageFolder+ getUid(req) +'/' + req.form["jobName"].value+'/'
		os.makedirs(path)
#		return "path:" + path
	else:	#Support for the old method of creating random directory
		while (intOrderID<0):
			intOrderID = random.randint(1,1000000000000)
			if (os.path.exists("/results/"+str(intOrderID)+"/")):
				intOrderID=-1
			else:
				path = "/results/"+str(intOrderID)+"/"
				os.makedirs(path)
				break
   	 			
   	for i in l:
		if (i.name.endswith("_radioButton")): continue
		if ("_" == i.name[-2]):
			ParameterName= i.name.split("_")[0]
			if (ParameterName in parameters): continue
			for p in range(1,9):		
				val=GetData(ParameterName+"_"+str(p),req,path)
				if (val !=""):
					if ("." in i.name): # For Classes
						classes=i.name.split('.')
						if (not classes[0] in parameters.keys()):
							parameters[classes[0]]={}
						parameters[classes[0]][classes[1]]=val
					else:	
						parameters[ParameterName]=val
					#return val
					break
		else:
			ParameterName= i.name
			val= GetData(ParameterName,req,path)
			if ("." in i.name): #For Classes
				classes=i.name.split('.')
				if (not classes[0] in parameters.keys()):
					parameters[classes[0]]={}
				parameters[classes[0]][classes[1]]=val
			else:
				parameters[ParameterName]=val

	outputs=parameters['ToolOutputs'].split(',')
	for out in outputs:
		parameters[out]=path+out

	#return parameters
	
			######################################################
			##     			                     		   	    ##
			##   	      	Get The tool command   	            ##
 			##    		      		                		    ##
			######################################################
	call=""
	if ("command" in req.form.keys()):
		call=req.form['command']
#		return call
				
	else:
		db = Utils.connectToDB()
		#cursor=db.cursor()
		db.query("SELECT Params FROM params WHERE ToolName = '" + parameters["toolName"] +"'")
		r=db.store_result()
		s = r.fetch_row()
		call=s[0]
		call=call[0]
	# Cheatea Template
	if ("#" in call): 
		from Cheetah.Template import Template
		return str( Template( source=str(call), searchList=[parameters] ) ).replace( "\n", " " ).replace( "\r", " " )
	
			########################################################
			##												      ##
			## 	Replace placeholder with parameter value	      ##
			##						      						  ##
			########################################################
	#return call
	params = call.split(" ")
	#return params
	executer =''
	for p in params:
		if ('$' in p):
			if ("=" in p):
				pair=p.split("=")
				executer+=pair[0]+"=" +parameters[parameter]
			parameter = p[1:]
			if ("out_file" in parameter or "out_" in parameter):
				executer += '"' + path + parameter +'"'
				AddOutPutRedirection=False
			else:
				if (" " in parameters[parameter]):
					executer+="'" + parameters[parameter]+"'"
				else:
					executer += parameters[parameter]
		else:
			executer += p
		
		#Add space if this is not the last item
		if (p != params[-1]): 
			executer +=' '
		
		
	#if ('$' in executer):
		
	#return executer
	JobID=""
	if (AddOutPutRedirection):
		run (executer + " > " + path + "Output.txt")
		#JobID=runWithUserManagement(executer + " > " + path + "Output.txt")
		
	else:
		run(executer)
		
		#JobID = runWithUserManagement(executer)
#	return JobID
	#if (JobID=="-1"):
	#	redirect(BaseURL+"files/error.html",req)
			#######################################################
			##			             				             ##
			##     Redirect to Output folder 'path' Index        ##
			##												     ##
			#######################################################
	
	global FilesURL
	redirect(FilesURL + "Results.html?id=" +  toolName+"/"+str(intOrderID),req) 
#End of Process Function

#This is the save function
def save(req):
	cookies = Cookie.get_cookies(req)
	if "FolderID" in cookies:
		folderID = str(cookies["FolderID"]).split("=")[1]
	else:
		return "Please set the folder ID cookie"
	toolName = req.form['name'].value
	hs=req.form["hs"].value
	cs=req.form["cs"].value
	param=req.form["param"].value
	global BaseTempPath
	f = open(BaseTempPath + FolderID + "/WebInt.html",'w')
	f.write(hs)
	f.flush()
	f.close()
	
	f = open(BaseTempPath + FolderID + "/style.css",'w')
	f.write(cs)
	f.flush()
	f.close()
		
	db = MySQLdb.connect(host="localhost", user="jsf", passwd="jsf",db="tools")
	cursor=db.cursor()
	st = "Insert into Reporters (ToolName,Params) Values('" + toolName  +"','" +param+"')"
	cursor=db.cursor()
	try:	
		cursor.execute(st)
        	cursor.close ()
	except:
		return "Problem while store the problem call."
			
	return "the form is saved successfully! <a href='../EditPage.iface'>Back to tool creation page</a>" 

# to make sure that the jobName is unique for the user (UUID)
def isUniqueJob(jobName,req):
	id=getUid(req)
	#return BaseStorageFolder + id +'/'+ jobName
	if (not os.path.exists(BaseStorageFolder + id +'/'+ jobName)):
		return "valid"
	return "This is job already exists. Choose another name"
