import os
import config,Utils
import simplejson
import xml.dom.minidom
import MySQLdb

toolID=""

def connectToDB():
	return Utils.connectToDB()

def addView(req,ToolName):
	db = connectToDB()
	from time import strftime
	EventTime =  strftime("%Y-%m-%d %H:%M:%S")
	IP=req.connection.remote_ip
	st= "insert into view (Tool,Date,IP) Values ('" + ToolName + "','" + EventTime + "','" +IP + "');"
	#return st;
	cursor=db.cursor()
        try:
			cursor.execute(st)
			db.commit()
			return "Saved"
        except Exception:
        	return "Error"


import os
import simplejson
import xml.dom.minidom
import elementtree.ElementTree as ET
import ToolParameter

def iterparent(tree):
    for parent in tree.getiterator():
        for child in parent:
            yield parent, child

def GetXmlText(element,name):
	if element.hasAttribute(name):
		return element.getAttribute(name)
	else:
		nameElements = element.getElementsByTagName(name)
		if len(nameElements) == 1:
			return nameElements[0].firstChild.nodeValue
		else:
			return ""
			
def StringAsBool( string ):
    if str( string ).lower() in ( 'true', 'yes', 'on' , '1' ):
        return Truege
    else:
        return False

def GetAttribute(element,attributeName,defaultValue):
	if element.hasAttribute(attributeName):
		return element.getAttribute(attributeName)
	else:
		return defaultValue

def LoadContionalParams(filePath,params):
	doc = xml.dom.minidom.parse(filePath)
	inputsNode = doc.getElementsByTagName("inputs")[0]
	conditionalNodes = inputsNode.getElementsByTagName("conditional")
	paramNames = {}
	for conditionalNode in conditionalNodes:
		name = conditionalNode.getElementsByTagName("param")[0].getAttribute("name")
		if name in params:
			value = params[name]		
			whenNodes = conditionalNode.getElementsByTagName("when")
			for whenNode in whenNodes:
				condition = whenNode.getAttribute("value")
				if condition == value:
					paramNodes = [paramNode for paramNode in whenNode.getElementsByTagName("param") if paramNode.parentNode == whenNode]
					for paramNode in paramNodes:
						paramNames[paramNode.getAttribute("name")] = condition
	return paramNames


def PrepareTool(filePath,params={},uuid=""):
	tool = {}
	outputParametersList=[]
	pages=None
	doc = ET.parse(filePath)
	toolNode = doc.getroot()
	global toolID
	toolID = toolNode.get("id")
	tool["tool_id"] = toolNode.get("id")
	#toolID=toolNode[0].getAttribute("id")
	#tool["tool_id"] = toolNode[0].getAttribute("id").replace(":"," - ")
	if (toolNode.find("pages")!=None):
		pages=toolNode.find("pages")
	command= toolNode.findtext("command")
	runner = (toolNode.get("runner"),False)
	inputsNode = toolNode.find("inputs")
	#form_html = '<div class="toolForm"><div class="toolFormTitle">Tool: ### </div><div class="toolFormBody"><input type="hidden" class="prop" name="###" id="'+tool["tool_id"]+'"/>'
	form_html = '<div class="toolForm"><input type="hidden" name="toolName" value="' + tool["tool_id"]+'"/><input type="hidden" name="command" value=\'' + command+'\'/>'
	dataFields=[]
	data_inputs = []	
	options_html='<br/><div class="InputDiv"><label class="InputLabel">Options</label><table> ';
	
	paramNames = LoadContionalParams(filePath,params)

	for parent, child in iterparent(inputsNode):
		if child.tag == "param":
			help=child.findtext("help")
			paramNode = child
			if not StringAsBool(paramNode.get("hidden")):
				name = paramNode.get("name")
				value = None
				if name in params:
					value = params[name]
				callbackFunction = "prop();"
				if parent.tag == "when":
					if name in paramNames:
						if parent.get("value") != paramNames[name]:
							continue
					else:
						continue
				elif parent.tag == "conditional":
					name=parent.get("name")+'.'+name
					callbackFunction = "LoadConditional('" + name + "');"
					
					#return name
				label = paramNode.get("label", paramNode.findtext("label"))
				if not label:
					label = name
				type = paramNode.get("type")
				if type == "hidden":
					continue
				elif type == "data":
					data_input = {}
					dataFields.append(name)
					form_html+=generateDataFieldHTML(label,name,help)
					data_input["extensions"] = ["data"]
					data_input["name"] = name
					data_input["label"] = label 
					data_inputs.append(data_input)
				elif type == "text" or type == "float" or type == "integer":
					#form_html += '<div class="form-row toolParam" type="text" id="' +  name + '"><label>'+label+'</label>'
					param = ToolParameter.TextToolParameter("",paramNode,callbackFunction=callbackFunction)
					options_html+= generateTextFieldHTML(param,label,name,value,help)
				elif type == "select":
					default = findDefaultValue(paramNode)
					if (parent.tag == "conditional"):
						paramNode.set("name",name)
					param = ToolParameter.SelectToolParameter("",paramNode,callbackFunction=callbackFunction)
					#form_html += '<div class="form-row toolParam" separator="'+param.separator+'" type="select" multiple="'+str(param.multiple)+'" id="' +  name + '"><label>'+label+'</label>'
					if (parent.tag == "conditional"):
						options_html+=generateSelectFieldHTML(param,label, name,value,help=None,conditional=True,defaultValue=default)
					else:
						options_html+=generateSelectFieldHTML(param,label, name,value,help=None)
					
				elif type == "boolean":
					param = ToolParameter.BooleanToolParameter("",paramNode,callbackFunction=callbackFunction)
					form_html += '<div class="form-row toolParam" truevalue="'+param.truevalue+'" falsevalue="'+param.falsevalue+'" type="boolean" id="' +  name + '"><label>'+label+'</label>'
					form_html += param.get_html(value=value) + '</div>'
	help=None		
	tool["data_inputs"] = data_inputs

	tool["name"] = "###"

	#prepare data outputs
	outputsNode = toolNode.find("outputs")
	dataNodes = outputsNode.getiterator("data")
	data_outputs = []

	for dataNode in dataNodes:
		name = dataNode.get("name")
		data_output = {}
		outputParametersList.append(name)
		#extend the extensions to take multiple extensions
		data_output["extension"] = dataNode.get("format","data")

		data_output["name"] = name
		data_output["label"] = dataNode.get("label", name)

		data_outputs.append(data_output) 
	

	"""
	helpText = toolNode.findtext("help")
	import sys
	sys.path.append(config.galaxyScripts)
	from util import rst_to_html
	helpText = rst_to_html(helpText)
	form_html += helpText
	"""
	form_html += options_html +"</table></div>"
	#form_html += "<div align='center'><input type='submit' value='run'/></div>"
	v = ','.join(dataFields)
	form_html += "<input type='hidden' name='dataFields' value='" + v+ "'/>"
	
	v=','.join(outputParametersList)
	form_html += "<input type='hidden' name='ToolOutputs' value='" + v+ "'/>"
	form_html += "<input type='hidden' name='jobName' id='jobName' value=''/>"
	form_html += "</div>" 
	#form_html += "<div align='center'><input type='submit' value='Run'/><input type='hidden' name='dataFields' value='" + dataParams+"'/></div></div></body></html>"
	tool["form_html"] = form_html
	pagesDict={}
	if (pages!=None):
		about=pages.getElementsByTagName("about")[0].firstChild.nodeValue
		if (about!=""):
			pagesDict["about"]=about
		#if (len(pages)>0):
	tool["pages"]=pagesDict
	
	#form_html += "</div></div></div>"
	#tool["form_html"] = form_html
	
	tool["data_outputs"] = data_outputs
	tool["type"] = "tool"
	return tool

def getParamAreaChange(toolID,paramName,paramValue):
	#return paramName,paramValue
	doc = ET.parse(GetToolPath(toolID))
	conditionName=paramName.split(".")[0]
	paramName=paramName.split(".")[1]
	toolNode = doc.getroot()
	conditionals=toolNode.findall("inputs/conditional")
	#return len(conditionals)
	html=""
	for condition in conditionals:
		if (condition.get("name") != conditionName): continue
		parameters = condition.findall("param")
		for param in parameters:
			if (param.get("name")==paramName): 
			#	return condition.parentNode.get("name")
				whens=condition.findall("when")
				#return len(whens)
				for when in whens:
					if (when.get("value")==paramValue):
				#		return "Params" + str(len(when.findall("param")))
		
						for p in when.findall("param"):
							label=p.get("label")
							name=condition.get("name")+'.'+ p.get("name")
							#return name
							help=p.findtext("help")
							value=""
							type=p.get("type")
							if (type=="data"):
								html+= generateDataFieldHTML(label,name,help)
								html=html.replace('class="InputDiv"','')
								html=html.replace('cols="50"','cols="45"')
	
							elif(type == "text" or type == "float" or type == "integer"):
								param = ToolParameter.TextToolParameter("",p,callbackFunction="")
								html+= generateTextFieldHTML(param,label,name,value,help)
							elif(type=="select"):
								param=ToolParameter.SelectToolParameter("",p,callbackFunction="")
								param.name=name
								#return str(param)
								html+= generateSelectFieldHTML(param,label,name,value,help)
							elif (type=="hidden"):
								continue
						break
			return html
						
def generateDataFieldHTML(label,name,help=None):
	st = '<div class="InputDiv"><label class="InputLabel">'+label+'</label>'
	if (help!=None):
		st+= '&nbsp;&nbsp;<img id="img_'+name+'" src="resources/help.gif" onmouseover="this.style.cursor=\'pointer\'" onclick="toggleHelp(\''+name+'Help\')"/><div id="'+name+'Help" class="help" style="display:none">'+help+'</div>'
	#st+='<table class="InputDiv"><tr><td>Enter Sequence</td><td><textarea rows="10" cols="50" name='+name+'_2></textarea></td></tr><tr><td>Upload File:</td><td><input type="file" name="'+name+'_1"/></td></tr></table></div>'
	st += """<table><tr style='font-size:12px'>
	<td>
		<input type='radio' name='{0}_radioButton' onclick="changeInputView('{0}','1')" checked/>Copy/Paste
	</td>
	<td>
		<input type='radio' name='{0}_radioButton' onclick="changeInputView('{0}','2')"/>Upload File
	</td>
	<td>
		<input type='radio' name='{0}_radioButton' onclick="changeInputView('{0}','3')" />My Store
	</td>
	<td>
		<input type='radio' name='{0}_radioButton' onclick="changeInputView('{0}','4')"/>Public ID
	</td>
	
	</tr>
	<tr><td colspan='4' id='{0}Area'><div><table><tr><td style="vertical-align:middle;">Paste Data:</td><td><textarea name="{0}" cols="50" rows="10"></textarea></td></tr></table></div></td></tr>
	</table>
	</div> """.format(name)

	return st				
def generateTextFieldHTML(param,label,name,value,help=None):
	st = '<tr><td><label>'+label+'</label></td><td>'					
	if (help!=None):
		st += '&nbsp;&nbsp;<img id="img_'+name+'" src="resources/help.gif" onmouseover="this.style.cursor=\'pointer\'" onclick="toggleHelp(\''+name+'Help\')"/></td></tr>'
		st +='<tr><td colspans="2" align="middle" ><div id="'+name+'Help" class="help" style="display: none;">'+help+'</div>  </td></tr>'
	else:
		st+="</td></tr>"
	st += "<tr><td>" + param.get_html(value=value) + "</td></tr>"
	return st
				
def generateSelectFieldHTML(param,label,name,value,help=None,conditional=False,defaultValue=""):
	#if (param.parent.tag=="conditional"):
	shortname=name
	#return defaultValue
	callbackFunction="LoadConditional('" + name + "');" #,'" + value + "');"
	if (conditional):
		param.name=name
		shortname=name.split(".")[1]
	#return param.name + ", "
	st = "<tr><td>" + label + "</td><td>" + param.get_html(value=value) + '</td></tr>'
	#_debug("st='" + st+ "'")
	s=""
	if (conditional):
		if (defaultValue!=""):
			global toolID
			s= getParamAreaChange(toolID,name,defaultValue)
	#		s=s.replace('<div class="InputDiv">','</div>')
	#		_debug(s)
			
			st += '<tr><td colspan="2"> <div id="con' + shortname+'Area" style="background-color:#cccccc;text-align:center;padding-left:15px"><table>'+s+'</table></div></td></tr>'
		else:
			st += '<tr id="con' + shortname+'Area" style="background-color:#cccccc;text-align:left;padding-left:15px">'+s+'</tr>'
	if (help!=None):
			st += '&nbsp;&nbsp;<img id="img_'+shortname+'" src="resources/help.gif" onmouseover="this.style.cursor=\'pointer\'" onclick="toggleHelp(\''+name+'Help\')"/></td></tr>'
			st +='<tr><td colspans="2" align="middle" ><div id="'+shortname+'Help" class="help" style="display: none;">'+help+'</div>  </td></tr>'
	#_debug(st)
	return st



#def GetToolPath(toolId):
	#doc = xml.dom.minidom.parse(config.toolsConfig)
	#node = doc.getElementsByTagName("toolbox")[0]
	#nodes = node.getElementsByTagName("tool")
	#for node in nodes :
    #        if node.getAttribute("id") == toolId:
    #            return node.getAttribute("file")
	#return ""
def GetToolPath(toolId):
	db = connectToDB()
	#cursor=db.cursor()
	st ="SELECT file from toolsList where id= '" + toolId +"'"
	#return st
	db.query(st)
	r=db.store_result()
	s = r.fetch_row()
	if (len(s)>0):
		if (s[0][0]!=""):
			return config.toolsDirect+ '/'+ s[0][0]
		else:
			return ""
	else: return ""
def GetViewedCount(toolID):
	db = connectToDB()
	#cursor=db.cursor()
	st ="SELECT count(*) FROM view WHERE Tool = '" + toolID +"'"
	#return st
	db.query(st)
	r=db.store_result()
	s = r.fetch_row()
	return s[0][0]

def GetRating(toolID):
	db = connectToDB()
	#cursor=db.cursor()
	st ="select Avg(score),count(*) from ratings  WHERE toolID = '" + toolID +"'"
	#return st
	db.query(st)
	r=db.store_result()
	s = r.fetch_row()
	if (s[0][0]==None):
		return str(0)+",,"+str(s[0][1])
	else:
		return str(s[0][0])+",,"+str(s[0][1])

def GetToolJson(req,toolID):
	filePath = GetToolPath(toolId=toolID)
	if (filePath!=""):
		tool = PrepareTool(filePath=filePath) 
	else:
		tool={}
		tool["form_html"]=""
		tool["tool_id"]=toolID
		tool["pages"]={}
		tool["pages"]["about"]=None
		tool["pages"]["download"]=None
		tool["pages"]["help"]=None
	rating = GetRating(toolID)
	values=rating.split(",,")
	tool["rating"] =   values[0]
	tool["ratingCount"]=values[1]
	tool["viewed"]=GetViewedCount(toolID)
	addView(req,toolID)
	return simplejson.dumps(tool)
	
def GetPage(toolID,page):
	db = connectToDB()
    #cursor=db.cursor()
	db.query("SELECT  " + page + " FROM pages WHERE ToolID = '" + toolID +"'")
	r=db.store_result()
	s = r.fetch_row()
	if (s!=None):
		if(len(s)>0):
			call=s[0]
			if (call[0]!=None):
				if(len(call[0])==0):
					return "There is no information avaliable for " + page
				else:
					return call[0]
			else:
				return "There is no information avaliable for " + page
		else:
			return "There is no information avaliable for " + page
	else:		
		return "There is no information avaliable for " + page
		
def SortDictionary(adict):
	iTuples = [(v,k) for k,v in adict.items()]
	iTuples = sorted(iTuples)
	return dict(iTuples)


def ListAvailableTools():
	toolSections = {}
	db =connectToDB()
	db.query("select distinct section from toolsList")
	r=db.store_result()
	Sections=r.fetch_row(maxrows=0,how=1)
	sectionsList=[]
	for section in Sections:
		sectionName=section["section"]
		
		db.query("select * from toolsList where section ='" + sectionName+"' and disabled=0")
		r=db.store_result()
		tools=r.fetch_row(maxrows=0,how=1)
		availableTools=[]
		for tool in tools:
			d={}
			d["id"] = tool["id"]
			d["name"]=tool["name"]
			d["paragraph"]=tool["paragraph"]
			availableTools.append(d)
		availableTools.sort()
		if (len(availableTools)>0):
			toolSections[sectionName.replace(' ','_')] = availableTools
			sectionsList.append(sectionName)
	sectionsList.sort()
	
	toolSections["categories"]=sectionsList
	return 	simplejson.dumps(toolSections)

def rate(toolID,score,req):
	db = connectToDB()
	
	IP=req.connection.remote_ip
	st= "insert into ratings (toolID,score,IP) Values ('" + toolID + "'," + score + ",'" +IP + "');"
	#return st;
	cursor=db.cursor()
        try:
			cursor.execute(st)
			db.commit()
			return "OK"
        except Exception:
        	return "Error"
def _debug(message):
	f=open('/home/mohamed/debug/ToolService.txt','a')
	f.write(message)
	f.flush()
	f.close()
def findDefaultValue(paramNode):
	options=paramNode.findall("option")
	#_debug(str(len(options))+'\n')
	for opt in options:
		#_debug(str(opt)+ "\t" + str(opt.get("selected"))+'\n')
		if (str(opt.get("selected")).lower()=="true"):
		#	_debug("'" + paramNode.get("name") +"' Selected: " + opt.get("value"))
			return opt.get("value")
	#_debug("default=''")
	return ""
